-------------------------------------------------------------------------------
--                L  O  C  A  L     V  A  R  I  A  B  L  E  S
-------------------------------------------------------------------------------

local addonName, L = ...;

local raceInfo =
{
  [0] = -- Totals
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {0,  0},
    keystoneId     = 0,
    keystoneSize   = 0,
    fragmentId     = 0,
  },
  [1] = -- Drust
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {3,  6},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 1535,
  },
  [2] = -- Zandalari
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {3,  6},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 1534,
  },
  [3] = -- Demonic
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  5},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 1174,
  },
  [4] = -- Highmountain Tauren
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  5},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 1173,
  },
  [5] = -- Highbourne
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {3,  5},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 1172,
  },
  [6] = -- Ogre
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 828,
  },
  [7] = -- Draenor Clans
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 19},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 821,
  },
  [8] = -- Arakkoa
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 829,
  },
  [9] = -- Mogu
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 752,
  },
  [10] = -- Pandaren
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2, 10},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 676,
  },
  [11] = -- Mantid
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  8},
    keystoneId     = 0,
    keystoneSize   = 20,
    fragmentId     = 754,
  },
  [12] = -- Vrykul
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  5},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 399,
  },
  [13] = -- Troll
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {3, 14},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 385,
  },
  [14] = -- Tol'vir
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {6,  7},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 401,
  },
  [15] = -- Orc
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {1,  9},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 397,
  },
  [16] = -- Nerubian
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  7},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 400,
  },
  [17] = -- Night Elf
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {7, 18},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 394,
  },
  [18] = -- Fossil
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {5, 12},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 393,
  },
  [19] = -- Draenei
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {2,  8},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 398,
  },
  [20] = -- Dwarf
  {
    name           = "",
    numArtifacts   = {0,  0},
    totalArtifacts = {4, 27},
    keystoneId     = 0,
    keystoneSize   = 12,
    fragmentId     = 384,
  },
};

local lootIds = {};

-- Mapping of spell ID to item ID(s) for all archaeology projects
local artifactInfo =
{
  [ 86857] = 63408,
  [ 86864] = 63409,
  [ 86865] = 63110,
  [ 86866] = 63112,
  [ 88180] = 63410,
  [ 88181] = 63411,
  [ 88262] = 63115,
  [ 88907] = 63120,
  [ 88908] = 63118,
  [ 88909] = 63111,
  [ 88910] = 63113,
  [ 88929] = 63109,
  [ 88930] = 63121,
  [ 89009] = 63129,
  [ 89012] = 63130,
  [ 89014] = 63131,
  [ 89693] = 60955,
  [ 89696] = 63407,
  [ 89701] = 63412,
  [ 89711] = 63413,
  [ 89717] = 63414,
  [ 89890] = 63523,
  [ 89891] = 63524,
  [ 89893] = 63525,
  [ 89894] = 63526,
  [ 89895] = 63527,
  [ 89896] = 63528,
  [ 90410] = 64337,
  [ 90411] = 64339,
  [ 90412] = 64340,
  [ 90413] = 64342,
  [ 90415] = 64343,
  [ 90419] = 64344,
  [ 90420] = 64345,
  [ 90421] = 64346,
  [ 90423] = 64347,
  [ 90429] = 64348,
  [ 90432] = 64349,
  [ 90433] = 64350,
  [ 90451] = 64354,
  [ 90452] = 64355,
  [ 90453] = 64356,
  [ 90458] = 64357,
  [ 90464] = 64358,
  [ 90493] = 64361,
  [ 90504] = 64362,
  [ 90506] = 64366,
  [ 90509] = 64367,
  [ 90518] = 64368,
  [ 90519] = 64371,
  [ 90521] = 64372,
  [ 90553] = 64373,
  [ 90558] = 64374,
  [ 90581] = 64375,
  [ 90608] = 64377,
  [ 90609] = 64378,
  [ 90610] = 64379,
  [ 90611] = 64381,
  [ 90612] = 64382,
  [ 90614] = 64383,
  [ 90616] = 64643,
  [ 90617] = 64385,
  [ 90618] = 64387,
  [ 90619] = 60954,
  [ 90622] = 64389,
  [ 90720] = 64417,
  [ 90728] = 64418,
  [ 90730] = 64419,
  [ 90732] = 64420,
  [ 90734] = 64421,
  [ 90831] = 64436,
  [ 90832] = 64437,
  [ 90833] = 64438,
  [ 90843] = 64644,
  [ 90853] = 64440,
  [ 90860] = 64442,
  [ 90861] = 64443,
  [ 90864] = 64444,
  [ 90968] = 64453,
  [ 90974] = 64454,
  [ 90975] = 64455,
  [ 90983] = 64456,
  [ 90984] = 64457,
  [ 90987] = 64458,
  [ 90988] = 64459,
  [ 90997] = 64460,
  [ 91008] = 64461,
  [ 91012] = 64462,
  [ 91014] = 64464,
  [ 91084] = 64467,
  [ 91089] = 64468,
  [ 91132] = 64473,
  [ 91133] = 64474,
  [ 91170] = 64475,
  [ 91188] = 64476,
  [ 91191] = 64477,
  [ 91197] = 64478,
  [ 91209] = 64479,
  [ 91211] = 64480,
  [ 91214] = 64481,
  [ 91215] = 64482,
  [ 91219] = 64483,
  [ 91221] = 64484,
  [ 91223] = 64485,
  [ 91224] = 64486,
  [ 91225] = 64487,
  [ 91226] = 64488,
  [ 91227] = 64489,
  [ 91757] = 64645,
  [ 91761] = 64646,
  [ 91762] = 64647,
  [ 91766] = 64648,
  [ 91769] = 64650,
  [ 91773] = 64651,
  [ 91775] = 64652,
  [ 91779] = 64653,
  [ 91780] = 64654,
  [ 91782] = 64655,
  [ 91785] = 64656,
  [ 91790] = 64657,
  [ 91792] = 64658,
  [ 91793] = 64659,
  [ 92137] = 60846,
  [ 92139] = 64880,
  [ 92145] = 64881,
  [ 92148] = 64883,
  [ 92163] = 64885,
  [ 92168] = 64904,
  [ 93440] = 66054,
  [ 93441] = 66055,
  [ 93442] = 66056,
  [ 93443] = 66057,
  [ 93444] = 66058,
  [ 98533] = 69764,
  [ 98556] = 69777,
  [ 98560] = 69776,
  [ 98569] = 69775,
  [ 98582] = 69821,
  [ 98588] = 69824,
  [113968] = {79896, 85557},
  [113971] = {79897, 85558},
  [113972] = {79898, 89178},
  [113973] = {79899, 89179},
  [113974] = {79900, 89180},
  [113975] = {79901, 89181},
  [113976] = {79902, 89182},
  [113977] = {79903, 89183},
  [113978] = {79904, 89184},
  [113979] = {79905, 89185},
  [113980] = 89684,
  [113981] = 89685,
  [113982] = {79908, 89169},
  [113983] = {79909, 89170},
  [113984] = {79910, 89171},
  [113985] = {79911, 89172},
  [113986] = {79912, 89173},
  [113987] = {79913, 89174},
  [113988] = {79914, 89175},
  [113989] = {79915, 89176},
  [113990] = {79916, 85477},
  [113991] = {79917, 89209},
  [113992] = 89611,
  [113993] = 89614,
  [139776] = {95375, 95383},
  [139779] = {95376, 95384},
  [139780] = {95377, 95385},
  [139781] = {95378, 95386},
  [139782] = {95379, 95387},
  [139783] = {95380, 95388},
  [139784] = {95381, 95389},
  [139785] = {95382, 95390},
  [139786] = 95391,
  [139787] = 95392,
  [168290] = {114141, 114142},
  [168291] = {114143, 114144},
  [168292] = {114145, 114146},
  [168293] = {114147, 114148},
  [168294] = {114149, 114150},
  [168295] = {114151, 114152},
  [168296] = {114153, 114154},
  [168297] = {114155, 114156},
  [168298] = {114157, 114158},
  [168299] = {114159, 114160},
  [168300] = {114161, 114162},
  [168301] = {114163, 114164},
  [168302] = {114165, 114166},
  [168303] = {114167, 114168},
  [168304] = {114169, 114170},
  [168305] = {114171, 114172},
  [168306] = {114173, 114174},
  [168307] = {114175, 114176},
  [168308] = {114177, 114178},
  [168309] = {114181, 114182},
  [168310] = {114183, 114184},
  [168311] = {114185, 114186},
  [168312] = {114187, 114188},
  [168313] = {114189, 114208},
  [168314] = {114190, 114209},
  [168315] = {114191, 114210},
  [168316] = {114192, 114211},
  [168317] = {114193, 114212},
  [168318] = {114194, 114213},
  [168319] = 117385,
  [168320] = 117384,
  [168321] = {114197, 114215},
  [168322] = {114198, 114216},
  [168323] = {114199, 114217},
  [168324] = {114200, 114218},
  [168325] = {114201, 114219},
  [168326] = {114202, 114220},
  [168327] = {114203, 114221},
  [168328] = {114204, 114222},
  [168329] = {114205, 114223},
  [168330] = {114206, 114224},
  [168331] = 117382,
  [172459] = 116985,
  [172460] = 117354,
  [172466] = 117380,
  [196470] = {130906, 130921},
  [196471] = {130907, 130922},
  [196472] = {130908, 130923},
  [196473] = {130909, 130924},
  [196474] = {130910, 130925},
  [196475] = {130911, 130926},
  [196476] = {130912, 130927},
  [196477] = {130913, 130928},
  [196478] = {130914, 130929},
  [196479] = {130915, 130930},
  [196480] = {130916, 130931},
  [196481] = {130917, 130932},
  [196482] = {130918, 130933},
  [196483] = {130919, 130934},
  [196484] = {130920, 130935},
  [257720] = {154913, 154931},
  [257721] = {154914, 154932},
  [257722] = {154915, 154933},
  [257723] = {154916, 154934},
  [257724] = {154917, 154935},
  [273812] = {160743, 160744},
  [273815] = 160740,
  [273817] = 161080,
  [273819] = 160753,
  [257715] = {154921, 154926},
  [257716] = {154922, 154927},
  [257717] = {154923, 154928},
  [257718] = {154924, 154929},
  [257719] = {154925, 154930},
  [273851] = {160741, 160742},
  [273852] = 160751,
  [273854] = 161089,
  [273855] = 160833,
};

local summaryMarkers = {};
local artifactTooltipFrame;

-------------------------------------------------------------------------------
--             L  O  C  A  L     D  E  F  I  N  I  T  I  O  N  S
-------------------------------------------------------------------------------

local archaeologyUpdateTotals;

-------------------------------------------------------------------------------
--                L  O  C  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to add info about how many artifacts have been completed
--
local function archaeologyCompletedUpdate()
  -- Local Variables
  local artifactIdx = 0;
  local frame = ArchaeologyFrameCompletedPage;
  local raceIdx = frame.raceFilter;
  local text;

  -- Update the titles with the completed progress
  for _, title in ipairs({frame.titleTop, frame.titleMid}) do
    -- Check if the top title is displayed
    if (title:IsShown()) then
      -- Get the current text
      text = title:GetText();
      if ((text ~= nil) and (text ~= "")) then
        -- Work out the rarity for the title
        if (text:find(ARCHAEOLOGY_RARE_COMPLETED, 1, true)) then
          artifactIdx = 1;
          text        = ARCHAEOLOGY_RARE_COMPLETED;
        elseif (text:find(ARCHAEOLOGY_COMMON_COMPLETED, 1, true)) then
          artifactIdx = 2;
          text        = ARCHAEOLOGY_COMMON_COMPLETED;
        else
          artifactIdx = 0;
        end

        -- Update the title's text
        if (artifactIdx > 0) then
          if ((NigglesDBC.settings.ProfArchProgress == true) and
              (raceInfo[raceIdx].totalArtifacts[artifactIdx] > 0)) then
            text = text.."|n"..raceInfo[raceIdx].numArtifacts[artifactIdx]..
              "/"..raceInfo[raceIdx].totalArtifacts[artifactIdx];
          end
          title:SetText(text);
        end
      end
    end
  end

  return;
end

--
-- Function to process events
--
local function archaeologyOnEvent(self, event, ...)
  -- Process the event
  if ((event == "RESEARCH_ARTIFACT_UPDATE") or
      (event == "RESEARCH_ARTIFACT_COMPLETE")) then
    RequestArtifactCompletionHistory();
  elseif (event == "RESEARCH_ARTIFACT_HISTORY_READY") then
    archaeologyUpdateTotals();
  end

  return;
end

--
-- Function called when an artifact is being solved. It issues a warning
-- if the character's Archaeology's skill is at or near the cap.
--
local function archaeologyOnSolveArtifact()
  -- Local Variables
  local _;
  local skillIdx;
  local skillRank;
  local skillMaxRank;

  -- Check if a warning should be given if required
  if (NigglesDBC.settings.ProfArchSkillCapWarn) then
    -- Get the info for Archaeology
    _, _, skillIdx = GetProfessions();
    if (skillIdx ~= nil) then
      _, _, skillRank, skillMaxRank = GetProfessionInfo(skillIdx);
    end

   -- Check if Archaeology is near or at the cap
    if ((type(skillRank) == "number") and
        (type(skillMaxRank) == "number") and
        (skillMaxRank < PROFESSION_RANKS[#PROFESSION_RANKS][1]) and
        (skillRank >= skillMaxRank-5)) then
      -- Issue a warning, if required
      SELECTED_CHAT_FRAME:AddMessage(format((skillRank >= skillMaxRank and
        L["ArchSkillAtCap"] or L["ArchSkillNearCap"]), skillName))
      PlaySound(SOUNDKIT.RAID_WARNING);
    end
  end

  return;
end

--
-- Function to update the progress of each race's artifact
--
local function archaeologySummaryUpdate()
  -- Local Variables
  local _;
  local bagIdx;
  local button;
  local summaryPage = ArchaeologyFrame.summaryPage;
  local itemCount;
  local numFragments;
  local numAdjustment;
  local numRaces = GetNumArchaeologyRaces();
  local numRequired;
  local numSlots;
  local numSockets;
  local raceKeystones = {};
  local raceName;
  local texture;

  -- Check if the archaeology panels should be enhanced
  if ((NigglesDBC.settings.ProfArchHilite == true) or
      (NigglesDBC.settings.ProfArchKeystones == true)) then
    -- Get the number of race keystones in the character's bags, if required
    if (NigglesDBC.settings.ProfArchKeystones) then
      for raceIdx = 1, numRaces do
        raceKeystones[raceIdx] = GetItemCount(raceInfo[raceIdx].keystoneId,
          false);
      end
    else
      raceKeystones = {};
    end

    -- Update the progress of each race's artifact
    for idx = 1, ARCHAEOLOGY_MAX_RACES do
      raceIdx = idx+(ARCHAEOLOGY_MAX_RACES*(summaryPage.currentPage-1));
      button  = summaryPage["race"..idx];
      if ((button ~= nil) and (raceIdx <= numRaces)) then
        -- Check if the player has started any artifacts for the race
        if (GetNumArtifactsByRace(raceIdx) > 0) then
          -- Get the number of fragments currently possessed and required
          raceName, _, _, numFragments, numRequired =
            GetArchaeologyRaceInfo(raceIdx);

          -- Update the number of fragments, if required
          numAdjustment = 0;
          if (NigglesDBC.settings.ProfArchKeystones == true) then
            -- Get the number of sockets the current artifact has
            SetSelectedArtifact(raceIdx);
            _, _, _, _, _, numSockets =  GetSelectedArtifactInfo();

            -- Update the number of fragments
            numAdjustment = (math.min(numSockets,
              (raceKeystones[raceIdx] or 0))*raceInfo[raceIdx].keystoneSize);
            numFragments = numFragments+numAdjustment;
          end

          -- Update the progress
          if ((NigglesDBC.settings.ProfArchHilite == true) and
              (numRequired > 0) and
              (numFragments >= numRequired)) then
            -- Create the marker, if required
            if (summaryMarkers[idx] == nil) then
              texture = button:CreateTexture(nil, "OVERLAY");
              texture:SetTexture("Interface\\RAIDFRAME\\ReadyCheck-Ready");
              texture:SetWidth(60);
              texture:SetHeight(60);
              texture:SetPoint("CENTER");
              summaryMarkers[idx] = texture;
            end

            -- Show the marker
            summaryMarkers[idx]:Show();
          elseif (summaryMarkers[idx] ~= nil) then
            -- Show the marker
            summaryMarkers[idx]:Hide();
          end

          -- Update the progress
          button.raceName:SetText(
            raceName.."|n"..numFragments..
            (numAdjustment > 0 and " (+"..numAdjustment..") " or "")..
            "/"..numRequired);
        end
      end
    end
  elseif (next(summaryMarkers) ~= nil) then
    -- Hide any markers
    for idx = 1, ARCHAEOLOGY_MAX_RACES do
      if (summaryMarkers[idx] ~= nil) then
        summaryMarkers[idx]:Hide();
      end
    end
  end

  return;
end

--
-- Function to update the number of completed artifacts for each race
--
archaeologyUpdateTotals = function()
  -- Local Variables
  local _;
  local completed;
  local current;
  local numArtifacts;
  local rarity;
  local totalArtifacts = raceInfo[0].numArtifacts;

  -- Check if the option is enabled
  if (NigglesDBC.settings.ProfArchProgress == true) then
    -- Reset the total number of artifacts
    totalArtifacts[1] = 0;
    totalArtifacts[2] = 0;

    -- Count the number of rare and common artifacts for each race
    for raceIdx = 1, #raceInfo do
      -- Assign the race's info to a more convenient variable
      current = raceInfo[raceIdx].numArtifacts;

      -- Reset the number of artifacts for the race
      current[1] = 0;
      current[2] = 0;

      -- Get the total number of artifacts for the race
      numArtifacts = GetNumArtifactsByRace(raceIdx);

      -- Count the number of rare and common artifacts for the race
      for artifactIdx = 1, numArtifacts do
        _, _, rarity, _, _, _, _, completed = GetArtifactInfoByRace(raceIdx,
          artifactIdx);
        -- Check the artifact has actually been completed
        if (completed > 0) then
          if (rarity == 1) then
            current[1] = current[1]+1;
          else
            current[2] = current[2]+1;
          end
        end
      end

      -- Update the total number of artifacts
      totalArtifacts[1] = totalArtifacts[1]+current[1];
      totalArtifacts[2] = totalArtifacts[2]+current[2];
    end

    -- Update the completed page, if it's shown
    if (ArchaeologyFrameCompletedPage:IsShown()) then
      archaeologyCompletedUpdate();
    end
  end

  return
end

--
-- Function called for mouse up events in the Artifact page
--
local function artifactPageOnMouseUp(self, mouseButton)
  -- Local Variables
  local pageIdx;
  local summaryPage = ArchaeologyFrame.summaryPage;

  -- Check the option is enabled and the right button was clicked
  if ((NigglesDBC.settings.ProfArchRClickBack == true) and
      (mouseButton == "RightButton")) then
    -- Save the current page for the summary page
    pageIdx = summaryPage.currentPage;

    -- Mimic clicking the 'Summary' button
    ArchaeologyFrame_OnTabClick(ArchaeologyFrameSummarytButton);

    -- Mimic clicking 'Next Page' button until correct page is reached
    while ((summaryPage.currentPage < pageIdx) and
           (summaryPage.nextPageButton:IsEnabled())) do
      ArchaeologyFrameSummary_PageClick(summaryPage.nextPageButton, true);
    end
  end
end

-------------------------------------------------------------------------------
--                 A  D  D  O  N     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to enable/disable the Niggles Archaeology features
--
L.archaeologyEnable = function()
  -- Show/hide the frame used to display results of the artifact solve
  if (artifactTooltipFrame ~= nil) then
    artifactTooltipFrame:SetShown(NigglesDBC.settings.ProfArchEnhIcon);
  end

  -- Update the markers on the summary page, if required
  if ((ArchaeologyFrame ~= nil) and (ArchaeologyFrame.summaryPage ~= nil)) then
    archaeologySummaryUpdate();
  end

  return;
end

--
-- Function to initialise the Niggles Archaeology functionality
--
L.archaeologyInitialise = function()
  -- Local Variables
  local _;
  local artifactName;
  local numRaces = #raceInfo;

  -- Get info about the races
  for idx = 1, numRaces do
    -- Get ID of the race's keystone
    _, _, raceInfo[idx].keystoneId = GetArchaeologyRaceInfo(idx);

    -- Add the race's keystone and fragment IDs to the loot IDs
    -- NOTE: The fragment IDs are made negative so they can't conflict with
    --       the item IDs
    if (raceInfo[idx].keystoneId > 0) then
      lootIds[raceInfo[idx].keystoneId] = true;
    end
    if (raceInfo[idx].fragmentId > 0) then
      lootIds[-raceInfo[idx].fragmentId] = true;
    end

    -- Update the total number of artifacts
    raceInfo[0].totalArtifacts[1] =
      raceInfo[0].totalArtifacts[1]+raceInfo[idx].totalArtifacts[1];
    raceInfo[0].totalArtifacts[2] =
      raceInfo[0].totalArtifacts[2]+raceInfo[idx].totalArtifacts[2];
  end

  return;
end

--
-- Function to check if an item is an archaeology keystone
--
L.archaeologyIsLoot = function(itemType, itemLink)
  -- Local Variables
  local _;
  local itemId = 0;

  -- Extract the item ID from the specified item link
  if (itemType == LOOT_SLOT_CURRENCY) then
    itemId = -tonumber(string.match(itemLink, "|Hcurrency:(%d+)[:|]"));
  elseif (itemType == LOOT_SLOT_ITEM) then
    itemId = tonumber(string.match(itemLink, "|Hitem:(%d+):"));
  end

  -- Check if the item ID is for an archaeology keystone or fragment
  return (lootIds[itemId] ~= nil);
end

--
-- Function called when Blizzard's Archaeology addon is loaded
--
L.archaeologyOnLoad = function()
  -- Local Variables
  local _;
  local frame;

  -- Add hooks to certain Archaeology functions
  hooksecurefunc("SolveArtifact", archaeologyOnSolveArtifact);
  hooksecurefunc("ArchaeologyFrame_UpdateSummary",
    archaeologySummaryUpdate);
  ArchaeologyFrame.summaryPage.UpdateFrame = ArchaeologyFrame_UpdateSummary;
  hooksecurefunc("ArchaeologyFrame_UpdateComplete",
    archaeologyCompletedUpdate);
  ArchaeologyFrame.completedPage.UpdateFrame = ArchaeologyFrame_UpdateComplete;

  -- Hook functions into the 'Prev' and 'Next' buttons on the 'Completed' page
  ArchaeologyFrameCompletedPagePrevPageButton:HookScript("OnMouseUp",
    L.hookUiFirstLastPage);
  ArchaeologyFrameCompletedPageNextPageButton:HookScript("OnMouseUp",
    L.hookUiFirstLastPage);

  -- Enable right clicking on the artifact page to go back to the summary page
  ArchaeologyFrameArtifactPage:EnableMouse(true);
  ArchaeologyFrameArtifactPage:HookScript("OnMouseUp", artifactPageOnMouseUp);

  -- Create the frame used to provide tooltips for the current artifact
  -- NOTE: This is done here, rather than in the XML file, because the
  --       Archaeology panel is implemented as an on-demand addon.
  frame = CreateFrame("Frame", nil, ArchaeologyFrameArtifactPage);
  frame:SetPoint("TOPLEFT",     "$parentIcon");
  frame:SetPoint("BOTTOMRIGHT", "$parentIcon");
  frame:SetFrameLevel(
    ArchaeologyFrameArtifactPageFinishedGlow:GetFrameLevel()+1);
  frame:SetScript("OnEnter",     NigglesArchaeologyTooltipOnEnter);
  frame:SetScript("OnLeave",     NigglesArchaeologyTooltipOnLeave);
  frame:SetScript("OnMouseDown", NigglesArchaeologyTooltipOnClick);
  frame:SetShown(NigglesDBC.settings.ProfArchEnhIcon);

  -- Register the frame for some events
  frame:RegisterEvent("RESEARCH_ARTIFACT_UPDATE");
  frame:RegisterEvent("RESEARCH_ARTIFACT_COMPLETE");
  frame:RegisterEvent("RESEARCH_ARTIFACT_HISTORY_READY");
  frame:HookScript("OnEvent", archaeologyOnEvent);

  -- Save the frame's handle
  artifactTooltipFrame = frame;

  -- Request artifact completion history from the server
  RequestArtifactCompletionHistory();

  -- Adjust the position of the races slightly on the Summary page
  ArchaeologyFrameSummaryPageRace1:SetPoint("TOPLEFT", 60, -75);

  return;
end

-------------------------------------------------------------------------------
--               G  L  O  B  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to process a click on the tooltip for an artifact
--
function NigglesArchaeologyTooltipOnClick(frame)
  -- Local Variables
  local artifactItems = nil;
  local hyperlink;

  -- Get the items for the selected artifact
  artifactItems = artifactInfo[select(8, GetSelectedArtifactInfo())];
  if (artifactItems ~= nil) then
    for _, itemId in ipairs(type(artifactItems) == "table" and
      artifactItems or {artifactItems}) do
      -- Get the artifact's hyperlink
      _, hyperlink = GetItemInfo(itemId)
      if (hyperlink ~= nil) then
        -- Call the standard handler
        HandleModifiedItemClick(hyperlink);
      end
    end
  end

  return;
end

--
-- Function to display the tooltip for an artifact
--
function NigglesArchaeologyTooltipOnEnter(frame)
  -- Local Variables
  local artifactItems;
  local prevTooltip = nil;
  local tooltip;

  -- Get the items for the selected artifact
  artifactItems = artifactInfo[select(8, GetSelectedArtifactInfo())];
  if (artifactItems ~= nil) then
    -- Set the first tooltip to the Game tooltip
    _G["NigglesTooltip1"] = GameTooltip;

    -- Display tooltips for all the artifact's items
    for idx, itemId in ipairs(type(artifactItems) == "table" and
      artifactItems or {artifactItems}) do
      -- Make sure the tooltip exists
      if (_G["NigglesTooltip"..idx] == nil) then
        tooltip = CreateFrame("GameTooltip", "NigglesTooltip"..idx, nil,
          "GameTooltipTemplate");
      else
        tooltip = _G["NigglesTooltip"..idx];
      end

      -- Position the tooltip
      if (prevTooltip == nil) then
        tooltip:SetOwner(frame, "ANCHOR_BOTTOMRIGHT", 0);
      else
        tooltip:SetOwner(prevTooltip, "ANCHOR_NONE", 0);
        tooltip:ClearAllPoints();
        tooltip:SetPoint("TOPLEFT", prevTooltip, "TOPRIGHT", 0, 0);
      end
      prevTooltip = tooltip;

      -- Set the tooltip
      tooltip:SetItemByID(itemId);
      tooltip:Show();
    end
  end

  return;
end

--
-- Function to hide the tooltip(s) for an artifact
--
function NigglesArchaeologyTooltipOnLeave(frame)
  -- Local Variables
  local idx = 1;

  -- Hide all the Niggles tooltips
  while (_G["NigglesTooltip"..idx] ~= nil) do
    _G["NigglesTooltip"..idx]:Hide();
    idx = idx+1;
  end

  return;
end
